#!/usr/bin/python
# -*- coding: utf-8 -*-

# i need to get my damb vox posts

import xml.dom.minidom
import urllib
import sys, os
import operator
import datetime, time

username = sys.argv[1]

outputFile = open(username + '.xml', 'w')

year = datetime.datetime.now().year
page = 1
failures = 0
errors = ""

posts = []

while failures < 2:

    if failures == 1: #last time we didn't get any posts; we must have reached the last page of the year. let's try the previous year.
        year -= 1
        page = 1

    print "Trying year %s page %s" % (year, page)
    
    newPosts = []

    rawPage = urllib.urlopen("http://%s.vox.com/library/posts/%s/page/%s" % (username, year, page)).read()
    
    try:
        xmlPage = xml.dom.minidom.parseString(rawPage)
    except xml.parsers.expat.ExpatError:
        errors += "Some kinda XML prollem with year %s page %s. " % (year, page)
        xmlPage = None
    
    if xmlPage:
    
        divs = xmlPage.getElementsByTagName('div')
        
        for oneDiv in divs:
            if oneDiv.getAttribute('class') == "post-asset asset":
                # this is a post
                theTitle = None
                theDate = None
                theContent = None
                theTags = []
                for onePossibleTitle in oneDiv.getElementsByTagName('h2'):
                    if onePossibleTitle.getAttribute('class') == "asset-name page-header2":
                        #this is the title of the post
                        theTitle = onePossibleTitle.getElementsByTagName('a')[0].childNodes[0].data
                for onePossibleDateline in oneDiv.getElementsByTagName('li'):
                    if onePossibleDateline.getAttribute('class') == "asset-meta-datetime-issued item":
                        #this is the dateline
                        theDate = onePossibleDateline.getElementsByTagName('span')[0].childNodes[0].data
                        theDate = datetime.datetime(*time.strptime(theDate.strip(), "%b %d, %Y")[0:5])
                for onePossibleContent in oneDiv.getElementsByTagName('div'):
                    if onePossibleContent.getAttribute('class') == "asset-content":
                        #this is the post content
                        theContent = onePossibleContent.toxml()
                for onePossibleMeta in oneDiv.getElementsByTagName('div'):
                    if onePossibleMeta.getAttribute('class') == "asset-meta asset-meta-footer":
                        #this is the meta footer
                        for onePossibleTags in onePossibleMeta.getElementsByTagName('span'):
                            if onePossibleTags.firstChild.data[:5] == "Tags:":
                                #this is the tag list
                                for oneTag in onePossibleTags.getElementsByTagName('a'):
                                    theTags.append(oneTag.firstChild.data)
                                    
                print "got post %s" % (theTitle)
                newPosts.append({'title': theTitle, 'date': theDate, 'content': theContent, 'tags': theTags})
        
        if len(newPosts):
            posts.extend(newPosts)
            failures = 0
        else:
            failures += 1
        
    page += 1

#print >> outputFile, """<?xml version="1.0"?>
#<rss version="2.0">
#   <channel>"""

for onePost in posts:
    
    tagHTML = ""
    for oneTag in onePost['tags']:
        tagHTML += "<category>%s</category>" % (oneTag)

    print >> outputFile, """
    <item>
    <title>%s</title>
    <pubDate>%s</pubDate>
    %s
    <content:encoded>%s</content:encoded>
    </item>
    """ % (onePost['title'].encode('utf-8'), onePost['date'], tagHTML.encode('utf-8'), ' '.join(onePost['content'].encode('utf-8').split()))

print errors
